package com.hzya.frame.plugin.zjmaterielsynchronizationevent.plugin;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.service.IZjMaterielSynchronizationEventService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 物料同步
 *
 * @author makejava
 * @since 2024-06-21 13:52:35
 */
public class ZjMaterielSynchronizationEventPluginInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(ZjMaterielSynchronizationEventPluginInitializer.class);
    @Autowired
    private IZjMaterielSynchronizationEventService zjMaterielSynchronizationEventService;

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "执行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "执行销毁方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "ZjMaterielSynchronizationEventPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "同步物料档案数据插件";
    }

    @Override
    public String getPluginLabel() {
        return "ZjMaterielSynchronizationEventPluginInitializer";
    }

    @Override
    public String getPluginType() {
        return "1";
    }

    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
        try {
            logger.info("======开始执行物料档案同步========");
            return zjMaterielSynchronizationEventService.materielSynchronization(requestJson);
        } catch (Exception e) {
            logger.info("======物料档案同步失败:{}========", e.getMessage());
            return BaseResult.getFailureMessageEntity("======物料档案同步失败:"+e.getMessage()+"========");
        }
    }
}
