package com.hzya.frame.plugin.zjmaterielsynchronizationevent.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.dao.IZjMaterielSynchronizationEventDao;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.entity.ZjMaterielSynchronizationEventDto;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.entity.ZjMaterielSynchronizationEventEntity;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.service.IZjMaterielSynchronizationEventService;
import com.hzya.frame.u8.base.inventory.dao.IInventoryDao;
import com.hzya.frame.u8.base.inventory.entity.InventoryEntity;
import com.hzya.frame.u8.base.inventory.entity.InventoryExtEntity;
import com.hzya.frame.u8.base.inventory.entity.InventorySubEntity;
import com.hzya.frame.u8.base.inventory.service.IInventoryExtService;
import com.hzya.frame.u8.base.inventory.service.IInventoryService;
import com.hzya.frame.u8.base.inventory.service.IInventorySubService;
import com.hzya.frame.u8.base.inventory.service.impl.InventoryService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.beanutils.BeanUtils;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.Resource;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Pattern;
import java.util.stream.Collectors;


/***
 * 物料档案同步插件
 * @content:
 * @author 👻👻👻👻👻👻👻👻 gjh
 * @date 2025-03-03 10:56
 * @param
 * @return
 **/
public class ZjMaterielSynchronizationEventServiceImpl extends BaseService<ZjMaterielSynchronizationEventEntity, String> implements IZjMaterielSynchronizationEventService {

    private IZjMaterielSynchronizationEventDao zjMaterielSynchronizationEventDao;

    @Autowired
    public void setZjMaterielSynchronizationEventDao(IZjMaterielSynchronizationEventDao zjMaterielSynchronizationEventDao) {
        this.zjMaterielSynchronizationEventDao = zjMaterielSynchronizationEventDao;
        this.dao = zjMaterielSynchronizationEventDao;
    }
    @Resource
    private IInventoryExtService inventoryExtService;
    @Autowired
    private IInventorySubService iInventorySubService;
    @Autowired
    private IInventoryDao inventoryDao;
    @Autowired
    private IInventoryService iInventoryService;
    private String zjoa = "zjoa";
    private String zju8 = "zju8";


    /**
     * @param requestJson
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 物料档案同步
     * @Date 11:39 上午 2025/3/17
     **/
    @Override
    @DSTransactional()
    public JsonResultEntity materielSynchronization(JSONObject requestJson) {
        logger.error("物料档案同步入参"+requestJson.toJSONString());
        JSONObject reqJson = new JSONObject();
        JSONObject jsonStr = requestJson.getJSONObject("jsonStr");
        JSONObject businessDataStr = jsonStr.getJSONObject("businessDataStr");
        String affairId = jsonStr.getString("affairId");
        String formAppId = jsonStr.getString("formAppId");
        String eventType = jsonStr.getString("eventType");
        switch (eventType) {
            case "onBeforeStart"://发起前事件，验证物料重复
                String formmain_id = getFormmain_id(businessDataStr);
                if(formmain_id == null || "".equals(formmain_id)){
                    return BaseResult.getFailureMessageEntity(eventType+"流程监听事件，未获取到主表id");
                }
                List<ZjMaterielSynchronizationEventEntity> list  = getListData(businessDataStr);
                //ZjMaterielSynchronizationEventEntity entity = new ZjMaterielSynchronizationEventEntity();
                //entity.setFormmain_id(formmain_id);
                //entity.setDataSourceCode(zjoa);
                //List<ZjMaterielSynchronizationEventEntity> list = zjMaterielSynchronizationEventDao.queryById(entity);
                if (list == null || list.size() == 0) {
                    return BaseResult.getFailureMessageEntity(eventType + "流程监听事件，未获取到明细数据");
                }
                List<InventoryEntity> inventoryEntities12 = new ArrayList<>();

                return checkData(list,false,inventoryEntities12);

            case "onBeforeFinishWorkitem":
            case "onProcessFinished"://流程结束事件，同步物料到U8C
                String id = getFormmain_id(businessDataStr);
                if(id == null || "".equals(id)){
                    return BaseResult.getFailureMessageEntity(eventType+"流程监听事件，未获取到主表id");
                }
                List<ZjMaterielSynchronizationEventEntity> list1  = getListData(businessDataStr);
                //ZjMaterielSynchronizationEventEntity entity1 = new ZjMaterielSynchronizationEventEntity();
                //entity1.setFormmain_id(id);
                //entity1.setDataSourceCode(zjoa);
                //List<ZjMaterielSynchronizationEventEntity> list1 = zjMaterielSynchronizationEventDao.queryById(entity1);
                if(list1 == null || list1.size() == 0){
                    return BaseResult.getFailureMessageEntity(eventType+"流程监听事件，未获取到明细数据");
                }
                List<InventoryEntity> inventoryEntities1 = new ArrayList<>();
                JsonResultEntity jsonResultEntity = checkData(list1,true,inventoryEntities1);
                if(jsonResultEntity == null){
                    return BaseResult.getFailureMessageEntity(eventType+"流程监听事件，校验发生系统错误");
                }
                if(!jsonResultEntity.isFlag()){
                    return jsonResultEntity;
                }
                //组装数据，保存数据
                try {
                    saveMaterielToU8(list1,inventoryEntities1,affairId);
                    //回写U8生成的编码
                    updateOaCode(list1);
                }catch (Exception e){
                    throw new RuntimeException("保存u8数据错误："+e.getMessage());
                }
                return BaseResult.getSuccessMessageEntity("保存u8成功");
            case "onStart"://流程发起 oa数据重新排序
                return BaseResult.getSuccessMessageEntity("排序暂不处理");
            default:
                return BaseResult.getFailureMessageEntity("未匹配到流程监听事件！当前传入的eventType：" + eventType);
        }
    }

    private List<ZjMaterielSynchronizationEventEntity> getListData(JSONObject businessDataStr) {
        Map<String,String> mj = getmeiji();

        List<ZjMaterielSynchronizationEventEntity> list = new ArrayList<>();
        JSONArray jsonArray = businessDataStr.getJSONArray("formson_0275");
        if(jsonArray!= null && jsonArray.size() > 0){
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject object = jsonArray.getJSONObject(i);
                ZjMaterielSynchronizationEventEntity zjMaterielSynchronizationEventEntity = new ZjMaterielSynchronizationEventEntity();
                zjMaterielSynchronizationEventEntity.setId(object.getString("id"));
                zjMaterielSynchronizationEventEntity.setFormmain_id(object.getString("formmain_id"));
                zjMaterielSynchronizationEventEntity.setField0004(object.getString("field0004"));//序号1
                if(object.getString("field0038") != null ){
                    zjMaterielSynchronizationEventEntity.setField0038(object.getString("field0038"));//是否更新 1是 0否
                    zjMaterielSynchronizationEventEntity.setField0038code(mj.get(object.getString("field0038")));//是否更新 1是 0否  todo
                }

                zjMaterielSynchronizationEventEntity.setField0005(object.getString("field0005"));//货品编码
                zjMaterielSynchronizationEventEntity.setField0006(object.getString("field0006"));//货品名称
                zjMaterielSynchronizationEventEntity.setField0007(object.getString("field0007"));//货品规格型号
                if(object.getString("field0008") != null ){
                    zjMaterielSynchronizationEventEntity.setField0008(object.getString("field0008"));//品牌
                    zjMaterielSynchronizationEventEntity.setField0008code(mj.get(object.getString("field0008")));//品牌 todo
                }
                if(object.getString("field0009") != null ){
                    zjMaterielSynchronizationEventEntity.setField0009(object.getString("field0009"));//规格书
                    zjMaterielSynchronizationEventEntity.setField0009code(mj.get(object.getString("field0009")));//规格书 todo
                }
                if(object.getString("field0010") != null ){
                    zjMaterielSynchronizationEventEntity.setField0010(object.getString("field0010"));//环保报告
                    zjMaterielSynchronizationEventEntity.setField0010code(mj.get(object.getString("field0010")));//环保报告 todo
                }

                zjMaterielSynchronizationEventEntity.setField0011(object.getString("field0011"));//ERP中相同型号不同品牌的编码

                if(object.getString("field0012") != null ){
                    zjMaterielSynchronizationEventEntity.setField0012(object.getString("field0012"));//优选等级
                    zjMaterielSynchronizationEventEntity.setField0012code(mj.get(object.getString("field0012")));//优选等级  todo
                }

                zjMaterielSynchronizationEventEntity.setField0013(object.getString("field0013"));//适用产品
                if(object.getString("field0014") != null ){
                    zjMaterielSynchronizationEventEntity.setField0014(object.getString("field0014"));//产品分类
                    zjMaterielSynchronizationEventEntity.setField0014code(mj.get(object.getString("field0014")));//产品分类 todo
                }

                zjMaterielSynchronizationEventEntity.setField0015(object.getString("field0015"));//备注
                zjMaterielSynchronizationEventEntity.setField0016(object.getString("field0016"));//最小包装量
                if(object.getString("field0017") != null ){
                    zjMaterielSynchronizationEventEntity.setField0017(object.getString("field0017"));//封装分类
                    zjMaterielSynchronizationEventEntity.setField0017code(mj.get(object.getString("field0017")));//封装分类 todo
                }
                if(object.getString("field0018") != null ){
                    zjMaterielSynchronizationEventEntity.setField0018(object.getString("field0018"));//申请原因
                    zjMaterielSynchronizationEventEntity.setField0018code(mj.get(object.getString("field0018")));//申请原因 todo
                }
                if(object.getString("field0019") != null ){
                    zjMaterielSynchronizationEventEntity.setField0019(object.getString("field0019"));//潮敏等级
                    zjMaterielSynchronizationEventEntity.setField0019code(mj.get(object.getString("field0019")));//潮敏等级 todo
                }
                if(object.getString("field0020") != null ){
                    zjMaterielSynchronizationEventEntity.setField0020(object.getString("field0020"));//是否退税软件
                    zjMaterielSynchronizationEventEntity.setField0020code(mj.get(object.getString("field0020")));//是否退税软件 todo
                }
                if(object.getString("field0022") != null ){
                    zjMaterielSynchronizationEventEntity.setField0022(object.getString("field0022"));//是否委外
                    zjMaterielSynchronizationEventEntity.setField0022code(mj.get(object.getString("field0022")));//是否委外 todo
                }



                zjMaterielSynchronizationEventEntity.setField0030(object.getString("field0030"));//上传附件1
                zjMaterielSynchronizationEventEntity.setField0031(object.getString("field0031"));//上传附件2

                if(object.getString("field0032") != null ){
                    zjMaterielSynchronizationEventEntity.setField0032(object.getString("field0032"));//负责人. 选人
                    ZjMaterielSynchronizationEventEntity user = new ZjMaterielSynchronizationEventEntity();
                    user.setDataSourceCode(zjoa);
                    user.setId(object.getString("field0032"));
                    List<ZjMaterielSynchronizationEventEntity> entities = zjMaterielSynchronizationEventDao.getuser(user);
                    if(entities != null && entities.size() > 0){
                        zjMaterielSynchronizationEventEntity.setField0032code(entities.get(0).getAccName());//负责人. 选人
                    }
                }
                if(object.getString("field0033") != null ){
                    zjMaterielSynchronizationEventEntity.setField0033(object.getString("field0033"));//产品阶段
                    zjMaterielSynchronizationEventEntity.setField0033code(mj.get(object.getString("field0033")));//产品阶段
                }

                if(object.getString("field0034") != null ){
                    zjMaterielSynchronizationEventEntity.setField0034(object.getString("field0034"));//客户名
                    zjMaterielSynchronizationEventEntity.setField0034code(mj.get(object.getString("field0034")));//客户名
                }
                if(object.getString("field0035") != null ){

                    zjMaterielSynchronizationEventEntity.setField0035(object.getString("field0035"));//是否带入档案
                    zjMaterielSynchronizationEventEntity.setField0035code(mj.get(object.getString("field0035")));//是否带入档案
                }
                if(object.getString("field0049") != null ){
                    zjMaterielSynchronizationEventEntity.setField0049(object.getString("field0049"));//
                    zjMaterielSynchronizationEventEntity.setField0049code(mj.get(object.getString("field0049")));//
                }

                zjMaterielSynchronizationEventEntity.setField0039(object.getString("field0039"));//开发号
                if(object.getString("field0040") != null ){
                    zjMaterielSynchronizationEventEntity.setField0040(object.getString("field0040"));//仓库名称
                    zjMaterielSynchronizationEventEntity.setField0040code(getSubstringBeforeDash(mj.get(object.getString("field0040"))));//仓库名称
                }
                if(object.getString("field0042") != null ){
                    zjMaterielSynchronizationEventEntity.setField0042(object.getString("field0042"));//物料属性
                    zjMaterielSynchronizationEventEntity.setField0042code(mj.get(object.getString("field0042")));//物料属性
                }


                zjMaterielSynchronizationEventEntity.setField0043(object.getString("field0043"));//物料中类编码
                zjMaterielSynchronizationEventEntity.setField0043code(getSubstringBeforeDash(object.getString("field0043")));//物料中类编码
                zjMaterielSynchronizationEventEntity.setField0044(object.getString("field0044"));//物料一级分类
                zjMaterielSynchronizationEventEntity.setField0045(object.getString("field0045"));//物料一级分类
                if(object.getString("field0047") != null ){
                    zjMaterielSynchronizationEventEntity.setField0047(object.getString("field0047"));//物料类别
                    zjMaterielSynchronizationEventEntity.setField0047code(mj.get(object.getString("field0047")));//物料类别
                }
                if(object.getString("field0048") != null ){
                    zjMaterielSynchronizationEventEntity.setField0048(object.getString("field0048"));//计量单位
                    zjMaterielSynchronizationEventEntity.setField0048code(mj.get(object.getString("field0048")));//计量单位
                }
                zjMaterielSynchronizationEventEntity.setAccName("UFDATA_997_2021.dbo.");
                zjMaterielSynchronizationEventEntity.setCaccId("997");
                list.add(zjMaterielSynchronizationEventEntity);
            }
        }
        return list;
    }

    private Map<String, String> getmeiji() {
        ZjMaterielSynchronizationEventEntity zjMaterielSynchronizationEventEntity = new ZjMaterielSynchronizationEventEntity();
        zjMaterielSynchronizationEventEntity.setDataSourceCode(zjoa);
        List<ZjMaterielSynchronizationEventEntity> entities = zjMaterielSynchronizationEventDao.getmeiji(zjMaterielSynchronizationEventEntity);
        Map<String, String> map = new HashMap<>();
        if(entities != null && entities.size() > 0){
            for (int i = 0; i < entities.size(); i++) {
                if(entities.get(i).getId().equals("4344562897656367384")){
                    map.put(entities.get(i).getId(),"不合格");

                }else if(entities.get(i).getId().equals("-2370628075712397249")){
                    map.put(entities.get(i).getId(),"优选1级");

                }else if(entities.get(i).getId().equals("6388260843022600446")){
                    map.put(entities.get(i).getId(),"优选2级");

                }else if(entities.get(i).getId().equals("407604312497538138")){
                    map.put(entities.get(i).getId(),"优选3级");

                }else if(entities.get(i).getId().equals("1992327618862992707")){
                    map.put(entities.get(i).getId(),"合格");

                }else if(entities.get(i).getId().equals("5555752418635433040")){
                    map.put(entities.get(i).getId(),"B机插类");

                }else if(entities.get(i).getId().equals("-8754053652716436337")){
                    map.put(entities.get(i).getId(),"C手插类");

                }else if(entities.get(i).getId().equals("-3057298014166890271")){
                    map.put(entities.get(i).getId(),"A贴片类");

                }else {
                    map.put(entities.get(i).getId(),entities.get(i).getAccName());
                }
            }
        }
        return map;
    }

    public  String getSubstringBeforeDash(String input) {
        int index = input.indexOf('-');
        if (index != -1) {
            return input.substring(0, index);
        }
        return input;
    }

    /**
     * @Author lvleigang
     * @Description  回写U8生成的编码
     * @Date 10:04 上午 2025/3/19
     * @param list
     * @return void
     **/
    private void updateOaCode(List<ZjMaterielSynchronizationEventEntity> list) {
        if(list != null && list.size() > 0){
            for (int i = 0; i < list.size(); i++) {
                ZjMaterielSynchronizationEventEntity entity = list.get(i);
                if("新增".equals(entity.getField0018code())){
                    entity.setDataSourceCode(zjoa);
                    zjMaterielSynchronizationEventDao.updatewlbm(entity);
                }
            }
        }
    }

    /**
     * @Author lvleigang
     * @Description  组装数据，保存数据
     * @Date 10:03 上午 2025/3/19
     * @param list
     * @return void
     **/
    private void saveMaterielToU8(List<ZjMaterielSynchronizationEventEntity> list,List<InventoryEntity> inventoryEntities,String affairId) throws Exception {
        Map<String,String> lsh = new HashMap<>();//当前流水号
        List<InventoryEntity> savedata = new ArrayList<>();

        for (int i = 0; i < list.size(); i++) {
            ZjMaterielSynchronizationEventEntity entity = list.get(i);
            InventoryExtEntity inventoryExtEntity = new InventoryExtEntity();
            InventorySubEntity inventorySubEntity = new InventorySubEntity();

            //获取最大流水号
            String maxnum = null;

            StringBuffer wlcode = new StringBuffer();
            //设置编码
            if("新增".equals(entity.getField0018code()) ){
                if(entity.getField0043code().equals("12400")
                        || entity.getField0043code().equals("12500")
                        || entity.getField0043code().equals("12418")
                        || entity.getField0043code().equals("12001")
                        || entity.getField0043code().equals("12003")
                        || entity.getField0043code().equals("12900")
                        || entity.getField0043code().equals("12005")){
                    //货品分类(12400-贴片电阻, 12500-贴片电容, 12418-贴片检测电阻, 12001-单面板, 12003-双面板, 12005-多层板)
                    //封装分类(贴片 0 , 其他 0 )
                    //当前分类最大流水号
                    //品牌(单据内填写品牌 01,未填写 00)
                    //是否委外
                    //是：勾选存货属性的委外，计划页面的委外属性
                    //否：取消勾选勾选存货属性的”委外”，计划页面的委外属性设置成“采购”
                    // 整体逻辑  12400物料分类 0贴片 002流水号  01品牌号
                    //例：12400  0 002 01
                    //货品分类以这几个开头的。封装分类是贴片，依然填0
                    if(lsh.get(entity.getField0043code()) != null){
                        maxnum = lsh.get(entity.getField0043code());
                    }
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        entity.setQuerycode(entity.getField0043code());
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length(),entity.getField0043code().length()+4);
                        maxnum = num;
                    }
                    String formattedNum = null;
                    char firstChar = Character.toUpperCase(maxnum.charAt(0));
                    if("9999".equals(maxnum)){
                        maxnum = "A000";
                        formattedNum = "A000";
                    }else if(firstChar >= 'A' && firstChar <= 'Z'){
                        String hm = maxnum.substring(maxnum.length() - 3);
                        if("999".equals(hm)){
                            hm = "000";
                            firstChar++;
                        }else {
                            hm = String.format("%03d", Integer.valueOf(hm)+1);
                        }
                        maxnum = firstChar+hm;
                        formattedNum = firstChar+hm;
                    }else {
                         formattedNum = String.format("%04d", Integer.valueOf(maxnum)+1);
                         maxnum = String.valueOf(Integer.valueOf(maxnum)+1);
                    }


                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code()).append(formattedNum);
                    if(entity.getField0008code() != null && !"".equals(entity.getField0008code())){
                        if("000".equals(entity.getField0008code())){
                            wlcode.append("00");

                        }else {
                            wlcode.append("01");
                        }
                    }else {
                        wlcode.append("00");
                    }
                }else if(entity.getField0043code().startsWith("1") || entity.getField0043code().startsWith("4") || entity.getField0043code().startsWith("5")){
                    //货品分类(区分是否是原材料通过分类首位1,4,5)
                    //封装分类(贴片 9 , 其他 0 )
                    //当前分类最大流水号
                    //品牌(单据内填写品牌 01,未填写 00)
                    //是否委外
                    //是：勾选存货属性的委外，计划页面的委外属性
                    //否：取消勾选勾选存货属性的”委外”，计划页面的委外属性设置成“采购”
                    // 整体逻辑  12100物料分类 0非贴片 002流水号  01品牌号
                    if(lsh.get(entity.getField0043code()) != null){
                        if(entity.getField0017code() != null && "A贴片类".equals(entity.getField0017code())){
                            maxnum = lsh.get(entity.getField0043code()+9);
                        }else {
                            maxnum = lsh.get(entity.getField0043code()+0);
                        }
                    }
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        if(entity.getField0017code() != null && "A贴片类".equals(entity.getField0017code())){
                            entity.setQuerycode(entity.getField0043code()+9);
                        }else {
                            entity.setQuerycode(entity.getField0043code()+0);
                        }
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length()+1,entity.getField0043code().length()+4);
                        maxnum = num;
                    }
                    String formattedNum = null;
                    char firstChar = Character.toUpperCase(maxnum.charAt(0));
                    if("999".equals(maxnum)){
                        maxnum = "A00";
                        formattedNum = "A00";
                    }else if(firstChar >= 'A' && firstChar <= 'Z'){
                        String hm = maxnum.substring(maxnum.length() - 2);
                        if("99".equals(hm)){
                            hm = "00";
                            firstChar++;
                        }else {
                            hm = String.format("%02d", Integer.valueOf(hm)+1);
                        }
                        maxnum = firstChar+hm;
                        formattedNum = firstChar+hm;
                    }else {
                        formattedNum = String.format("%03d", Integer.valueOf(maxnum)+1);
                        maxnum = String.valueOf(Integer.valueOf(maxnum)+1);
                    }

                    //String formattedNum = String.format("%03d", ++maxnum);
                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code());
                    if(entity.getField0017code() != null && "A贴片类".equals(entity.getField0017code())){
                        wlcode.append("9");
                    }else {
                        wlcode.append("0");
                    }
                    wlcode.append(formattedNum);
                    if(entity.getField0008code() != null && !"".equals(entity.getField0008code())){
                        if("000".equals(entity.getField0008code())){
                            wlcode.append("00");

                        }else {
                            wlcode.append("01");
                        }
                    }else {
                        wlcode.append("00");
                    }
                }else if(entity.getField0043code().startsWith("6") || entity.getField0043code().startsWith("7") || entity.getField0043code().startsWith("8") || entity.getField0043code().startsWith("9")){
                    //货品分类(区分是否是”产品”通过分类首位6,7,8,9)
                    //当前分类最大流水号（编码第6-9是顺序号）
                    //最后2位默认11
                    //整体逻辑  62100物料分类  0001流水  11默认
                    //例：62100 0001 11
                    if(lsh.get(entity.getField0043code()) != null){
                        maxnum = lsh.get(entity.getField0043code());
                    }
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        entity.setQuerycode(entity.getField0043code());
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length(),entity.getField0043code().length()+4);
                        maxnum = num;
                    }
                    String formattedNum = null;
                    char firstChar = Character.toUpperCase(maxnum.charAt(0));
                    if("9999".equals(maxnum)){
                        maxnum = "A000";
                        formattedNum = "A000";
                    }else if(firstChar >= 'A' && firstChar <= 'Z'){
                        String hm = maxnum.substring(maxnum.length() - 3);
                        if("999".equals(hm)){
                            hm = "000";
                            firstChar++;
                        }else {
                            hm = String.format("%03d", Integer.valueOf(hm)+1);
                        }
                        maxnum = firstChar+hm;
                        formattedNum = firstChar+hm;
                    }else {
                        formattedNum = String.format("%04d", Integer.valueOf(maxnum)+1);
                        maxnum = String.valueOf(Integer.valueOf(maxnum)+1);
                    }

                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code());
                    wlcode.append(formattedNum);
                    wlcode.append("11");

                }else if(entity.getField0043code().startsWith("A")){
                    //货品分类(区分是”软件”通过分类首位A)
                    //当前分类最大流水号（编码第6-10是顺序号）
                    //最后1位默认1
                    //整体逻辑  A0110物料分类  00001流水  1默认
                    //例：A0110 00001 1
                    if(lsh.get(entity.getField0043code()) != null){
                        maxnum = lsh.get(entity.getField0043code());
                    }
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        entity.setQuerycode(entity.getField0043code());
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length(),entity.getField0043code().length()+5);
                        maxnum = num;
                    }
                    String formattedNum = null;
                    char firstChar = Character.toUpperCase(maxnum.charAt(0));
                    if("99999".equals(maxnum)){
                        maxnum = "A0000";
                        formattedNum = "A0000";
                    }else if(firstChar >= 'A' && firstChar <= 'Z'){
                        String hm = maxnum.substring(maxnum.length() - 4);
                        if("9999".equals(hm)){
                            hm = "0000";
                            firstChar++;
                        }else {
                            hm = String.format("%04d", Integer.valueOf(hm)+1);
                        }
                        maxnum = firstChar+hm;
                        formattedNum = firstChar+hm;
                    }else {
                        formattedNum = String.format("%05d", Integer.valueOf(maxnum)+1);
                        maxnum = String.valueOf(Integer.valueOf(maxnum)+1);
                    }
                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code());
                    wlcode.append(formattedNum);
                    wlcode.append("1");
                }else if(entity.getField0043code().startsWith("T")){
                    //未填写物料(T 草清单)
                    //货品分类(区分是”草清单”通过分类首位 T)
                    //当前分类最大流水号(编码第 2-11 是顺序号)
                    //整体逻辑 T物料分类 0000000001流水
                    if(lsh.get(entity.getField0043code()) != null){
                        maxnum = lsh.get(entity.getField0043code());
                    }
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        entity.setQuerycode(entity.getField0043code());
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length(),entity.getField0043code().length()+10);
                        maxnum = num;
                    }
                    String formattedNum = null;

                    formattedNum = String.format("%010d", Integer.valueOf(maxnum)+1);
                    maxnum = String.valueOf(Integer.valueOf(maxnum)+1);
                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code());
                    wlcode.append(formattedNum);
                }
            }else if("修改".equals(entity.getField0018code()) || "增加替代".equals(entity.getField0018code()) || "升级".equals(entity.getField0018code())){
                wlcode.append(entity.getField0005());
            }
            //设置其他字段
            //物料编码
            InventoryEntity inventoryEntity = new InventoryEntity();
            //设置全部字段属性
            if("修改".equals(entity.getField0018code())){
                InventoryEntity queryCz = new InventoryEntity();
                queryCz.setDataSourceCode(zju8);
                queryCz.setcInvCode(entity.getField0005());
                List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                if(queryCzList != null && queryCzList.size() > 0){
                    BeanUtils.copyProperties(inventoryEntity,queryCzList.get(0));
                }
                inventoryExtEntity.setDataSourceCode(zju8);
                inventoryExtEntity.setcInvCode(entity.getField0005());
                inventoryExtEntity = inventoryExtService.getInvExt(inventoryExtEntity);
                inventoryExtEntity.setDataSourceCode(zju8);

                inventorySubEntity.setDataSourceCode(zju8);
                inventorySubEntity.setcInvSubCode(entity.getField0005());
                inventorySubEntity = iInventorySubService.getInvSub(inventorySubEntity);
                inventorySubEntity.setDataSourceCode(zju8);
                // 变更日期  变更人
                inventoryEntity.setdModifyDate(new Date());//变更日期
                ZjMaterielSynchronizationEventEntity user = new ZjMaterielSynchronizationEventEntity();
                user.setDataSourceCode(zjoa);
                user.setAffairId(affairId);
                List<ZjMaterielSynchronizationEventEntity> usersa = zjMaterielSynchronizationEventDao.getUser(user);
                if(usersa != null && usersa.size() > 0){
                    inventoryEntity.setcModifyPerson(usersa.get(0).getUserName());//变更人
                }
            }else {
                for (int i1 = 0; i1 < inventoryEntities.size(); i1++) {
                    if(inventoryEntities.get(i1).getcInvCode().equals(entity.getField0043code())){
                        BeanUtils.copyProperties(inventoryEntity,inventoryEntities.get(i1));
                        break;
                    }
                }
                inventoryExtEntity.setDataSourceCode(zju8);
                inventoryExtEntity.setcInvCode(entity.getField0043code());
                inventoryExtEntity = inventoryExtService.getInvExt(inventoryExtEntity);
                inventoryExtEntity.setDataSourceCode(zju8);
                inventorySubEntity.setDataSourceCode(zju8);
                inventorySubEntity.setcInvSubCode(entity.getField0043code());
                inventorySubEntity = iInventorySubService.getInvSub(inventorySubEntity);
                inventorySubEntity.setDataSourceCode(zju8);
                // 建档日期  启用日期 建档人

                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                inventorySubEntity.setdInvCreateDatetime(sdf.format(new Date()));//建档日期
                inventoryEntity.setdSDate(new Date());//启用日期

                ZjMaterielSynchronizationEventEntity user = new ZjMaterielSynchronizationEventEntity();
                user.setDataSourceCode(zjoa);
                user.setAffairId(affairId);
                List<ZjMaterielSynchronizationEventEntity> usersa = zjMaterielSynchronizationEventDao.getUser(user);
                if(usersa != null && usersa.size() > 0){
                    inventoryEntity.setcCreatePerson(usersa.get(0).getUserName());//建档人
                }

            }
            inventoryExtEntity.setcInvCode(wlcode.toString());
            inventorySubEntity.setcInvSubCode(wlcode.toString());
            entity.setField0005(wlcode.toString());
            //定制化字段
            inventoryEntity.setDataSourceCode(zju8);
            inventoryEntity.setAcc_name(entity.getAccName());
            inventoryEntity.setCacc_id(entity.getCaccId());
            logger.error("物料编码"+wlcode);
            //inventoryEntity.setAcc_name("UFDATA_998_2014.dbo.");
            //inventoryEntity.setCacc_id("998");
            inventoryEntity.setcInvCode(wlcode.toString());//物料编码
            inventoryEntity.setcInvCCode(entity.getField0043code());//物料中类
            inventoryEntity.setcInvAddCode(entity.getField0045());//  货品代码
            inventoryEntity.setcInvName(entity.getField0006());//  货品名称
            inventoryEntity.setcInvStd(entity.getField0007());//  货品规格
            inventoryEntity.setcInvDefine8(entity.getField0008code());//  品牌  SPT
            inventoryEntity.setcInvDefine3(entity.getField0017code());//  工艺属性 A贴片类
            inventoryEntity.setcDefWareHouse(entity.getField0040code());//   仓库名称
            inventoryEntity.setcInvDefine1(entity.getField0012code());// 优选等级  合格
            inventoryEntity.setcInvDefine4(entity.getField0033code());//  产品阶段
            inventoryEntity.setcInvDefine7(entity.getField0042code());//  物料属性 OEM
            if(entity.getField0022code() != null && "是".equals(entity.getField0022code())){
                inventoryEntity.setbProxyForeign("1");//  是否委外
                inventoryEntity.setbBomMain("1");//  计划属性
                inventoryEntity.setiPlanDefault(2);//  计划属性
            }else {
                inventoryEntity.setbProxyForeign("0");//  是否委外
                inventoryEntity.setbBomMain("0");//  计划属性
                //inventoryEntity.setbPurchase("0");//  计划属性
            }
            inventoryExtEntity.setCidefine7(entity.getField0049code());// 认证信息
            inventoryExtEntity.setCidefine6(entity.getField0034code());// 客户名
            inventoryExtEntity.setCidefine1(entity.getField0032code());//负责人
            inventoryExtEntity.setCidefine2(entity.getField0039());// 开发号/项目
            inventoryEntity.setInvExtEntity(inventoryExtEntity);
            inventoryEntity.setInvSubEntity(inventorySubEntity);
            savedata.add(inventoryEntity);
            if("新增".equals(entity.getField0018code()) || "增加替代".equals(entity.getField0018code()) || "升级".equals(entity.getField0018code())){
                iInventoryService.saveInventory(inventoryEntity);
            }else if("修改".equals(entity.getField0018code())){
                iInventoryService.updateInventory(inventoryEntity);
            }
        }
    }




    /**
     * @Author lvleigang
     * @Description  解析参数id
     * @Date 11:38 上午 2025/3/18
     * @param businessDataStr
     * @return java.lang.String
     **/
    private String getFormmain_id(JSONObject businessDataStr) {
        String id = null;
        if(businessDataStr == null ){
            return id;
        }
        JSONObject formmain_0274 = businessDataStr.getJSONObject("formmain_0274");
        if(formmain_0274 == null){
            return id;
        }
        id = formmain_0274.getString("id");
        return id;
    }

    /**
     * @Author lvleigang
     * @Description  验证物料重复
     * @Date 1:58 下午 2025/3/17
     * @param list 数据
     * @param flag 该项是否校验
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    private JsonResultEntity checkData(List<ZjMaterielSynchronizationEventEntity> list, boolean flag,List<InventoryEntity> inventoryEntities) {
        StringBuffer str = new StringBuffer();
        Map<String, Integer> elementCountMap = new HashMap<>();
        /*
        1、必填校验：发起
				物料中类、货品编码（修改必填）
				保存
				物料中类、货品编码（修改必填）、货品代码、品牌、客户名、优选等级、开发号、物料属性、是否委外
        2、物料编码和货品代码不为空时，判断两个是否一样
        3、判断存货分类里面如果有6或7，有一个必须有另一个
        4、规格型号正则校验（不允许全角符号）
        5、发起、保存判断物料分类是否在U8中存在
        */
        for (int i = 0; i < list.size(); i++) {
            ZjMaterielSynchronizationEventEntity entity = list.get(i);
            if(entity.getField0004() == null || "".equals(entity.getField0004())){

                return BaseResult.getFailureMessageEntity("序号为空");
            }
            if(entity.getField0043code() == null || "".equals(entity.getField0043code())){
                str.append("序号为"+entity.getField0004()+"明细行的物料中类为空。");
                //return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的物料中类为空");
            }else {
                elementCountMap.put(entity.getField0043code(), elementCountMap.getOrDefault(entity.getField0043code(), 0) + 1);
                //判断存货分类里面如果有6或7，有一个必须有另一个
                //if(entity.getField0043code().startsWith("6")){
                //    num++;
                //}
                //if(entity.getField0043code().startsWith("7")){
                //    num1++;
                //}
            }
            //if(entity.getField0018code() == null || "".equals(entity.getField0018code())){
            //    return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的申请原因为空");
            //}
            if(!"新增".equals(entity.getField0018code())){
                if(entity.getField0005() == null || "".equals(entity.getField0005())){
                    str.append("序号为"+entity.getField0004()+"明细行的货品编码为空。");
                }else {
                    if(entity.getField0043code().equals("12400")
                            || entity.getField0043code().equals("12500")
                            || entity.getField0043code().equals("12418")
                            || entity.getField0043code().equals("12001")
                            || entity.getField0043code().equals("12003")
                            || entity.getField0043code().equals("12900")
                            || entity.getField0043code().equals("12005")){
                        //货品分类(12400-贴片电阻, 12500-贴片电容, 12418-贴片检测电阻, 12001-单面板, 12003-双面板, 12005-多层板)
                        //封装分类(贴片 0 , 其他 0 )
                        //当前分类最大流水号
                        //品牌(单据内填写品牌 01,未填写 00)
                        //是否委外
                        //是：勾选存货属性的委外，计划页面的委外属性
                        //否：取消勾选勾选存货属性的”委外”，计划页面的委外属性设置成“采购”
                        // 整体逻辑  12400物料分类 0贴片 002流水号  01品牌号
                        //例：12400  0 002 01
                        //货品分类以这几个开头的。封装分类是贴片，依然填0
                        String subStrfz = entity.getField0005().substring(5, 6);
                        if(subStrfz.equals("9")){
                            str.append("序号为"+entity.getField0004()+"明细行的物料编码的封装分类，编码对应不应该填写9");
                        }
                        String subStr = entity.getField0005().substring(10, 11);
                        // mw = 00  pp =000或空
                        //mw ！= 00  pp ！=000或！空
                        if(subStr.equals("0")){
                            if(entity.getField0008code() != null && !"000".equals(entity.getField0008code())){
                                str.append("序号为"+entity.getField0004()+"明细行的编码和品牌不一致");
                            }
                        }else {
                            if(entity.getField0008code() == null || "000".equals(entity.getField0008code())){
                                str.append("序号为"+entity.getField0004()+"明细行的编码和品牌不一致");
                            }
                        }
                        //if(entity.getField0008code() != null && !"".equals(entity.getField0008code())){
                        //    if("000".equals(entity.getField0008code())){
                        //        if(!subStr.equals("00")){
                        //            str.append("序号为"+entity.getField0004()+"明细行的物料编码品牌为000，编码对应应该填写00");
                        //        }
                        //    }else {
                        //        if(!subStr.equals("01")){
                        //            str.append("序号为"+entity.getField0004()+"明细行的物料编码品牌存在，编码对应应该填写01");
                        //        }
                        //    }
                        //}else {
                        //    if(!subStr.equals("00")){
                        //        str.append("序号为"+entity.getField0004()+"明细行的物料编码品牌为空，应该填写00");
                        //    }
                        //}
                    }else if(entity.getField0043code().startsWith("1") || entity.getField0043code().startsWith("4") || entity.getField0043code().startsWith("5")){
                        //货品分类(区分是否是原材料通过分类首位1,4,5)
                        //封装分类(贴片 9 , 其他 0 )
                        //当前分类最大流水号
                        //品牌(单据内填写品牌 01,未填写 00)
                        //是否委外
                        //是：勾选存货属性的委外，计划页面的委外属性
                        //否：取消勾选勾选存货属性的”委外”，计划页面的委外属性设置成“采购”
                        // 整体逻辑  12100物料分类 0非贴片 002流水号  01品牌号

                        String subStrfz = entity.getField0005().substring(5, 6);

                        if(entity.getField0017code() != null && "A贴片类".equals(entity.getField0017code())){
                            if(!subStrfz.equals("9")){
                                str.append("序号为"+entity.getField0004()+"明细行的物料编码的封装分类为贴片，编码对应应该填写9");
                            }
                        }else {
                            if(!subStrfz.equals("0")){
                                str.append("序号为"+entity.getField0004()+"明细行的物料编码的封装分类不是贴片，编码对应应该填写0");
                            }
                        }
                        String subStr = entity.getField0005().substring(10, 11);
                        // mw = 00  pp =000或空
                        //mw ！= 00  pp ！=000或！空
                        if(subStr.equals("0")){
                            if(entity.getField0008code() != null && !"000".equals(entity.getField0008code())){
                                str.append("序号为"+entity.getField0004()+"明细行的编码和品牌不一致");
                            }
                        }else {
                            if(entity.getField0008code() == null || "000".equals(entity.getField0008code())){
                                str.append("序号为"+entity.getField0004()+"明细行的编码和品牌不一致");
                            }
                        }

                        //if(entity.getField0008code() != null && !"".equals(entity.getField0008code())){
                        //    if("000".equals(entity.getField0008code())){
                        //        if(!subStr.equals("00")){
                        //            str.append("序号为"+entity.getField0004()+"明细行的物料编码品牌为000，编码对应应该填写00");
                        //        }
                        //    }else {
                        //        if(!subStr.equals("01")){
                        //            str.append("序号为"+entity.getField0004()+"明细行的物料编码品牌存在，编码对应应该填写01");
                        //        }
                        //    }
                        //}else {
                        //    if(!subStr.equals("00")){
                        //        str.append("序号为"+entity.getField0004()+"明细行的编码和品牌不一致");
                        //    }
                        //}
                    }else if(entity.getField0043code().startsWith("6") || entity.getField0043code().startsWith("7") || entity.getField0043code().startsWith("8") || entity.getField0043code().startsWith("9")){
                        //货品分类(区分是否是”产品”通过分类首位6,7,8,9)
                        //当前分类最大流水号（编码第6-9是顺序号）
                        //最后2位默认11
                        //整体逻辑  62100物料分类  0001流水  11默认
                        //例：62100 0001 11
                        //String subStr = entity.getField0005().substring(9, 11);
                        //if(!subStr.equals("11")){
                        //    str.append("序号为"+entity.getField0004()+"明细行的物料编码，末尾编码应该填写11");
                        //}

                    }else if(entity.getField0043code().startsWith("A")){
                        //货品分类(区分是”软件”通过分类首位A)
                        //当前分类最大流水号（编码第6-10是顺序号）
                        //最后1位默认1
                        //整体逻辑  A0110物料分类  00001流水  1默认
                        //例：A0110 00001 1
                        //String subStr = entity.getField0005().substring(10, 11);
                        //if(!subStr.equals("1")){
                        //    str.append("序号为"+entity.getField0004()+"明细行的物料编码，末尾编码应该填写1");
                        //}
                    }else if(entity.getField0043code().startsWith("T")){
                        //货品分类(区分是”软件”通过分类首位A)
                        //当前分类最大流水号（编码第6-10是顺序号）
                        //最后1位默认1
                        //整体逻辑  A0110物料分类  00001流水  1默认
                        //例：A0110 00001 1
                        //String subStr = entity.getField0005().substring(10, 11);
                        //if(!subStr.equals("1")){
                        //    str.append("序号为"+entity.getField0004()+"明细行的物料编码，末尾编码应该填写1");
                        //}
                    }
                }
            }
            if("新增".equals(entity.getField0018code())){
                if(entity.getField0005() != null && !"".equals(entity.getField0005())){
                    str.append("序号为"+entity.getField0004()+"明细行的申请原因与实际不符。");
                }
            }
            if("修改".equals(entity.getField0018code())) {
                if(entity.getField0045() == null || "".equals(entity.getField0045())){
                     //str.append("序号为"+entity.getField0004()+"明细行的货品代码为空");
                }else {
                    ZjMaterielSynchronizationEventEntity querywl = new ZjMaterielSynchronizationEventEntity();
                    querywl.setDataSourceCode(zju8);
                    querywl.setField0045(entity.getField0045());
                    List<InventoryEntity> inventoryEntities1 = zjMaterielSynchronizationEventDao.queryInventory(querywl);
                    if(inventoryEntities1 == null || inventoryEntities1.size() == 0){
                        str.append("序号为"+entity.getField0004()+"明细行的货品代码不存在");
                    }
                }
            }else {
                if(entity.getField0045() != null && !"".equals(entity.getField0045())){//货品代码不为空时
                    ZjMaterielSynchronizationEventEntity querywl = new ZjMaterielSynchronizationEventEntity();
                    querywl.setDataSourceCode(zju8);
                    querywl.setField0045(entity.getField0045());
                    List<InventoryEntity> inventoryEntities1 = zjMaterielSynchronizationEventDao.queryInventory(querywl);
                    if(inventoryEntities1 != null && inventoryEntities1.size() > 0){
                        str.append("序号为"+entity.getField0004()+"明细行的货品代码已存在");
                    }
                }
            }

            //if(flag){
            //    if(entity.getField0008code() == null || "".equals(entity.getField0008code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的品牌为空");
            //    }
            //}
            if(entity.getField0034code() != null && !"".equals(entity.getField0034code())){//客户名
                ZjMaterielSynchronizationEventEntity querywl = new ZjMaterielSynchronizationEventEntity();
                querywl.setDataSourceCode(zju8);
                querywl.setField0034code(entity.getField0034code());
                Integer counts = zjMaterielSynchronizationEventDao.queryKh(querywl);
                if(counts == null || counts ==  0){
                    str.append("序号为"+entity.getField0004()+"明细行的客户名不存在");
                }

            }
            //if(flag){
            //    if(entity.getField0034code() == null || "".equals(entity.getField0034code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的客户名为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0012code() == null || "".equals(entity.getField0012code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的优选等级为空");
            //    }
            //}
            //  开发号
            if(entity.getField0039() != null && !"".equals(entity.getField0039())){//开发号
                ZjMaterielSynchronizationEventEntity querywl = new ZjMaterielSynchronizationEventEntity();
                querywl.setDataSourceCode(zju8);
                querywl.setField0039(entity.getField0039());
                Integer counts = zjMaterielSynchronizationEventDao.queryXM(querywl);
                if(counts == null || counts ==  0){
                    str.append("序号为"+entity.getField0004()+"明细行的开发号不存在");
                }
            }
            //if(flag){
            //    if(entity.getField0042code() == null || "".equals(entity.getField0042code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的物料属性为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0022code() == null || "".equals(entity.getField0022code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的是否委外为空");
            //    }
            //}
            //物料编码和货品代码不为空时，判断两个是否一样
            if(entity.getField0005() != null && !"".equals(entity.getField0005())
                && entity.getField0045() != null && !"".equals(entity.getField0045())){
                if(!entity.getField0005().equals(entity.getField0045())){
                    //str.append("序号为"+entity.getField0004()+"明细行的物料编码和货品代码不一致。");

                    //return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的物料编码和货品代码不一致");
                }
            }
            //规格型号正则校验（不允许全角符号）
            if(entity.getField0007() != null && !"".equals(entity.getField0007())){
                List<Character> fullwidthSymbols = new ArrayList<>();
                for (int e = 0; e < entity.getField0007().length(); e++) {
                    char c = entity.getField0007().charAt(e);
                    // 全角符号的 Unicode 范围
                    if ((c >= 0xFF01 && c <= 0xFF5E) || c == 0x3000) {
                        fullwidthSymbols.add(c);
                    }
                }
                StringBuffer msg = new StringBuffer();
                if(fullwidthSymbols!= null && fullwidthSymbols.size() > 0){
                    for (int i1 = 0; i1 < fullwidthSymbols.size(); i1++) {
                        if(i1 == 0){
                            msg.append(fullwidthSymbols.get(i1));
                        }else {
                            msg.append("，"+fullwidthSymbols.get(i1));
                        }

                    }
                    str.append("序号为"+entity.getField0004()+"明细行的规格型号包含全角符号："+msg+"。");



                }



            }
        }
        Map<String,String> stringMap = new HashMap<>();
        //判断存货分类里面如果有6或7，有一个必须有另一个
        if(elementCountMap != null && elementCountMap.size() > 0){
            for (Map.Entry<String, Integer> entry : elementCountMap.entrySet()) {
                String key = entry.getKey();
                Integer value = entry.getValue();
                if(key.startsWith("6")){
                    Integer o = elementCountMap.getOrDefault("7"+key.substring(1),0);
                    if(value != o){
                        stringMap.put(key+"和"+"7"+key.substring(1),"1");
                    }
                }
                if(key.startsWith("7")){
                    Integer o = elementCountMap.getOrDefault("6"+key.substring(1),0);
                    if(value != o){
                        stringMap.put("6"+key.substring(1)+"和"+key,"1");
                    }
                }
            }
        }
        if(stringMap != null && stringMap.size() > 0){
            String result = stringMap.keySet().stream()
                    .collect(Collectors.joining(","));
                str.append(result+"不是成对出现。");
        }


        //查询u8物料
        ZjMaterielSynchronizationEventDto querywl = new ZjMaterielSynchronizationEventDto();
        querywl.setDataSourceCode(zju8);
        querywl.setZjMaterielSynchronizationEventEntities(list);
        List<InventoryEntity> inventoryEntities1 = zjMaterielSynchronizationEventDao.queryInventoryEntity(querywl);
        inventoryEntities.addAll(inventoryEntities1);
        if(inventoryEntities == null || inventoryEntities.size() == 0){
            str.append("物料分类在U8中不存在"+"。");
        }
        //发起、保存判断物料分类是否在U8中存在
        for (int i = 0; i < list.size(); i++) {
            ZjMaterielSynchronizationEventEntity entity = list.get(i);
            boolean flags = false;
            for (int i1 = 0; i1 < inventoryEntities.size(); i1++) {
                if(entity.getField0043code().equals(inventoryEntities.get(i1).getcInvCode())){
                    flags = true;
                    break;
                }
            }
            if(!flags){
                str.append("序号为"+entity.getField0004()+"明细行的物料分类在U8中不存在"+"。");

            }
        }

        //	新增
        //		A6789分类时：判断存货分类和规格型号在物料分类中是否存在，存在不允许新增
        //		145分类时：判断规格型号是否存在，存在不允许新增
        //		其他类型，直接返回提示类型错误
        //	修改判断
        //		物料编码判断U8是否存在，不存在的提示
        if(flag){
            Integer xzCount = 0;
            Set<String> js = new HashSet<>();
            for (int i = 0; i < list.size(); i++) {
                ZjMaterielSynchronizationEventEntity entity = list.get(i);
                if("修改".equals(entity.getField0018code())){
                    //查询u8物料
                    InventoryEntity queryCz = new InventoryEntity();
                    queryCz.setDataSourceCode(zju8);
                    queryCz.setcInvCode(entity.getField0005());
                    List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                    if(queryCzList == null || queryCzList.size() == 0 ){
                        //return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行修改的物料编码在U8中不存在");
                        str.append(entity.getField0005()+"在U8中不存在,请检查货品编号"+"。");

                    }
                }else if("增加替代".equals(entity.getField0018code()) || "升级".equals(entity.getField0018code())){
                    //查询u8物料
                    InventoryEntity queryCz = new InventoryEntity();
                    queryCz.setDataSourceCode(zju8);
                    queryCz.setcInvCode(entity.getField0005());
                    List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                    if(queryCzList != null && queryCzList.size() > 0 ){
                        //return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行修改的物料编码在U8中不存在");
                        str.append(entity.getField0005()+"在U8中已存在,请检查货品编号"+"。");
                    }
                }else {//新增
                    xzCount++;
                    if(entity.getField0043code().startsWith("A")
                            || entity.getField0043code().startsWith("6")
                            || entity.getField0043code().startsWith("7")
                            || entity.getField0043code().startsWith("8")
                            || entity.getField0043code().startsWith("9")){
                        //查询u8物料
                        InventoryEntity queryCz = new InventoryEntity();
                        queryCz.setDataSourceCode(zju8);
                        queryCz.setcInvCCode(entity.getField0043code());//存货分类/存货大类编码
                        queryCz.setcInvStd(entity.getField0007());//规格型号
                        List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                        if(queryCzList != null && queryCzList.size() > 0 ){
                            str.append("序号为"+entity.getField0004()+"明细行"+entity.getField0018code()+"的存货分类和规格型号已存在"+"。");

                        }
                        js.add(entity.getField0043code()+entity.getField0007());
                    }else if(entity.getField0043code().startsWith("1")
                            || entity.getField0043code().startsWith("4")
                            || entity.getField0043code().startsWith("5")){
                        //查询u8物料
                        InventoryEntity queryCz = new InventoryEntity();
                        queryCz.setDataSourceCode(zju8);
                        queryCz.setcInvStd(entity.getField0007());//规格型号
                        List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                        if(queryCzList != null && queryCzList.size() > 0 ){
                            str.append("序号为"+entity.getField0004()+"明细行"+entity.getField0018code()+"的规格型号已存在"+"。");

                        }
                        js.add(entity.getField0007());
                    }else {
                        str.append("序号为"+entity.getField0004()+"明细行"+entity.getField0018code()+"的物料中类不正确"+"。");

                    }
                }
            }
            if(js.size() != xzCount ){
                str.append("新增/增加替代/升级的明细行存货分类和规格型号或者规格型号存在重复"+"。");
            }
        }
        if(str != null && str.toString() != null && !"".equals(str.toString())){
            return BaseResult.getFailureMessageEntity("校验失败："+str.toString());
        }else {
            return BaseResult.getSuccessMessageEntity("校验成功");
        }
    }


}
