package com.hzya.frame.plugin.ofs.plugin;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class OfsGetOrderInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(OfsGetOrderInitializer.class);

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "ofsGetOrderInitializer";
    }

    @Override
    public String getPluginName() {
        return "数据库备份下发";
    }

    @Override
    public String getPluginLabel() {
        return "ofsGetOrderInitializer";
    }

    @Override
    public String getPluginType() {
        return "1";
    }



    /**
     * @Author lvleigang
     * @Description  获取ofs订单数据
     * @Date 3:12 下午 2024/10/24
     * @param requestJson
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {

        //System.out.println("获取ofs订单数据");
        //System.out.println("获取ofs订单发送数据");
        //QueryOfsSoSaleOutVo queryOfsSoSaleOutVo = new QueryOfsSoSaleOutVo();
        //queryOfsSoSaleOutVo.setPageNo(1L);
        //queryOfsSoSaleOutVo.setPageSize(200L);
        ////queryOfsSoSaleOutVo.setCode("123123123");
        //queryOfsSoSaleOutVo.setCreated_start("2024-10-24 01:00:00");
        //queryOfsSoSaleOutVo.setCreated_end("2024-10-24 17:00:00");
        //queryOfsSoSaleOutVo.setClientCode("LETS");
        //String data = JSON.toJSONString(queryOfsSoSaleOutVo);
        ////2024年7月30日 12:16:38生成签名
        //OfsHexUtil ofsHexUtil = new OfsHexUtil();
        //String timestamp =   String.valueOf(System.currentTimeMillis());
        //Map<String, String> params = new HashMap<>();
        //params.put("data", data);
        //String sign = ofsHexUtil.sign("ofs.salesOrder.search", data,"json", "1023142858", "1.0", "382e4a2584027a36ac9431103", timestamp);
        //String url = "http://39.98.58.229/api/edi/u8c/ofs/in?api=ofs.salesOrder.search&format=json&appKey=1023142858&v=1.0&sign="+sign+"&timestamp="+timestamp;
        //
        //String returnData = postParams(url,params);


        return BaseResult.getSuccessMessageEntity("获取成功");

    }
    //适用于post请求并传送form-data数据（同样适用于post的Raw类型的application-json格式）
    public  String postParams(String url, Map<String, String> params) {
        //创建自定义的httpclient对象
        CloseableHttpClient client = HttpClients.custom().build();
        HttpPost post = new HttpPost(url);
        CloseableHttpResponse res = null;
        try {
            List<NameValuePair> nvps = new ArrayList<NameValuePair>();
            Set<String> keySet = params.keySet();
            for (String key : keySet) {
                nvps.add(new BasicNameValuePair(key, params.get(key)));
            }
            post.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
            res = client.execute(post);
            HttpEntity entity = res.getEntity();
            return EntityUtils.toString(entity, "utf-8");
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                res.close();
                client.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return "";
    }




}
