package com.hzya.frame.u8.base.identity.service.impl;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.u8.base.identity.dao.IUAIdentityDao;
import com.hzya.frame.u8.base.identity.entity.UAIdentityEntity;
import com.hzya.frame.u8.base.identity.service.IUAIdentityService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.ibatis.session.SqlSession;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * @Description 单据主键生成控制表  service
 * @Author xiang2lin
 * @Date 2021/12/27 16:36
 **/
@Service
public class UAIdentityServiceImpl extends BaseService<UAIdentityEntity,String> implements IUAIdentityService {

    Logger logger = LogManager.getLogger(IUAIdentityService.class);

    private IUAIdentityDao uaIdentityDao;

    @Autowired
    public void setIuaIdentityDao(IUAIdentityDao dao) {
        this.uaIdentityDao = dao;
        this.dao = dao;
    }


    /**
     * 查询销售订单最大主键
     *
     * @return
     * @throws Exception
     */
    @Override
    public UAIdentityEntity queryMaxSaleOrderId(String acc_id, String type) throws Exception {
        try{
            UAIdentityEntity uaIdentityEntity = new UAIdentityEntity();
            uaIdentityEntity.setCacc_id(acc_id);
            uaIdentityEntity.setcVouchType(type);
            List<UAIdentityEntity> list = (List<UAIdentityEntity>) uaIdentityDao.query(uaIdentityEntity,"com.hzya.frame.u8.base.identity.dao.impl.UAIdentityDaoImpl.entity_list_base_cvouchtype");
            if (CollectionUtils.isNotEmpty(list)){
                return list.get(0);
            }
        }catch (Exception e){
            logger.error(e.getMessage());
        }
        return null;
    }

    /**
     * 更新最大编号
     *
     * @param entity
     * @return
     * @throws Exception
     */
    @Override
    public  UAIdentityEntity updateMaxSaleOrderId(UAIdentityEntity entity) throws Exception {
        if (null != entity.getiFatherId() && null != entity.getiChildId()){
            try{
                //最大号+1
                UAIdentityEntity uaIdentityEntity = new UAIdentityEntity();
                uaIdentityEntity.setCacc_id(entity.getCacc_id());
                uaIdentityEntity.setcVouchType(entity.getcVouchType());
                uaIdentityEntity.setiFatherId(entity.getiFatherId()+1);
                uaIdentityEntity.setiChildId(entity.getiChildId()+1);
                uaIdentityEntity.setAcc_name(entity.getAcc_name());
                uaIdentityDao.update("com.hzya.frame.u8.base.identity.dao.impl.UAIdentityDaoImpl.entity_update_iFatherId",uaIdentityEntity);
                //sqlSession.update("com.hzya.frame.u8cinterface.identity.entity.UAIdentityEntity.UAIdentityEntity_update_iFatherId",uaIdentityEntity);
                return uaIdentityEntity;
            }catch (Exception e){
                logger.error(e.getMessage());
            }
        }
        return null;
    }
}
