package com.hzya.frame.u8.base.inventory.service.impl;
import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.u8.base.inventory.dao.IInventoryExtDao;
import com.hzya.frame.u8.base.inventory.entity.InventoryExtEntity;
import com.hzya.frame.u8.base.inventory.service.IInventoryExtService;
import com.hzya.frame.web.exception.BaseSystemException;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @description: 存货档案扩展自定义项  service
 * @tableName:   Inventory_extradefine 
 * @entityName:  InventoryExtEntity
 * @author: 	 gjh
 * @history:	 1.0
 */
@Service(value="Inventory_extradefineService")
public class  InventoryExtServiceImpl extends BaseService<InventoryExtEntity,String> implements IInventoryExtService {
	
	protected IInventoryExtDao inventoryextDao;
	
	@Autowired
	public void setInventoryExtDao(IInventoryExtDao dao) {
		this.inventoryextDao = dao;
		this.dao=dao;
	}

	/**
	 * 根据存货编码查询存货扩展自定义项
	 *
	 * @param entity
	 * @return
	 */
	@DS("#entity.dataSourceCode")
	@Override
	public InventoryExtEntity getInvExt(InventoryExtEntity entity) throws Exception {
		if (null != entity && StrUtil.isNotEmpty(entity.getcInvCode())){
			InventoryExtEntity extEntity = new InventoryExtEntity();
			extEntity.setCInvCode(entity.getCInvCode());
			extEntity.setDataSourceCode(entity.getDataSourceCode());
			List<InventoryExtEntity> query = inventoryextDao.query(extEntity);
			if (CollectionUtils.isNotEmpty(query)){
				if (query.size() > 1){
					throw new BaseSystemException("根据存货编码"+entity.getcInvCode()+"查询到多条扩展自定义项数据，请检查数据准确性");
				}
				return query.get(0);
			}
		}
		return null;
	}

	@DS("#entity.dataSourceCode")
	@Override
	public void saveOrUpdateInv(InventoryExtEntity entity) throws Exception {
		InventoryExtEntity invExt = getInvExt(entity);
		if (null != invExt){
			inventoryextDao.update(entity);
		}else {
			inventoryextDao.save(entity);
		}
	}
}
