package com.hzya.frame.u8.base.inventory.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.u8.base.inventory.dao.IInventorySubDao;
import com.hzya.frame.u8.base.inventory.entity.InventorySubEntity;
import com.hzya.frame.u8.base.inventory.service.IInventorySubService;
import com.hzya.frame.web.exception.BaseSystemException;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description
 * @Author xiangerlin
 * @Date 2025/3/13 16:42
 **/
@Service
public class InventorySubServiceImpl extends BaseService<InventorySubEntity,String> implements IInventorySubService {

    private IInventorySubDao inventorySubDao;

    @Autowired
    public void setInventorySubDao(IInventorySubDao dao) {
        this.inventorySubDao = dao;
        this.dao = dao;
    }

    /**
     * 根据存货编码查存货子表
     *
     * @param entity
     * @return
     */
    @DS("#entity.dataSourceCode")
    @Override
    public InventorySubEntity getInvSub(InventorySubEntity entity) throws Exception {
        if (null != entity && StrUtil.isNotEmpty(entity.getcInvSubCode())){
            InventorySubEntity subEntity = new InventorySubEntity();
            subEntity.setcInvSubCode(entity.getcInvSubCode());
            subEntity.setDataSourceCode(entity.getDataSourceCode());
            List<InventorySubEntity> query = inventorySubDao.query(subEntity);
            if (CollectionUtils.isNotEmpty(query)){
                if (query.size() > 1){
                    throw new BaseSystemException("根据存货编码"+entity.getcInvSubCode()+"查询到多条副表数据，请检查数据准确性");
                }
                return query.get(0);
            }
        }
        return null;
    }

    @DS("#entity.dataSourceCode")
    @Override
    public void saveOrUpdateInvSub(InventorySubEntity entity) throws Exception {
        InventorySubEntity invSub = getInvSub(entity);
        if (null != invSub){
            inventorySubDao.update(entity);
        }else {
            inventorySubDao.save(entity);
        }
    }
}
